[ VIGRA Homepage | Function Index | Class Index | Namespaces | File List | Main Page ]

| ColumnIterator< IMAGE_ITERATOR > Class Template Reference Image Iterator Adapters |

Iterator adapter to linearly access columns. More...

`#include <vigra/imageiteratoradapter.hxx>`

Inherits IMAGE_ITERATOR.

## Public Types

typedef IMAGE_ITERATOR | Adaptee
typedef IMAGE_ITERATOR::difference_type::MoveY | difference_type
typedef IMAGE_ITERATOR::index_reference | index_reference
typedef std::random_access_iterator_tag | iterator_category
typedef IMAGE_ITERATOR::value_type | PixelType
typedef IMAGE_ITERATOR::pointer | pointer
typedef IMAGE_ITERATOR::reference | reference
typedef IMAGE_ITERATOR::value_type | value_type

## Public Member Functions

| ColumnIterator (IMAGE_ITERATOR const &i)
ColumnIterator & | operator= (ColumnIterator const &i)
ColumnIterator & | operator= (IMAGE_ITERATOR const &i)
Navigation
ColumnIterator & | operator++ ()
ColumnIterator | operator++ (int)
ColumnIterator & | operator-- ()
ColumnIterator | operator-- (int)
ColumnIterator & | operator+= (int d)
ColumnIterator & | operator-= (int d)
Methods
ColumnIterator | operator+ (int d) const
ColumnIterator | operator- (int d) const
int | operator- (ColumnIterator const &c) const
bool | operator== (ColumnIterator const &c) const
bool | operator!= (ColumnIterator const &c) const
bool | operator< (ColumnIterator const &c) const
reference | operator* () const
index_reference | operator[] (int d) const
pointer | operator-> () const
Adaptee & | adaptee () const

## Detailed Description

### template<class IMAGE_ITERATOR>
class vigra::ColumnIterator< IMAGE_ITERATOR >

Iterator adapter to linearly access columns.

This iterator may be initialized from any standard ImageIterator, a MultibandImageIterator and so on. It gives you STL-compatible (random access iterator) access to one column of the image. If the underlying iterator is a const iterator, the column iterator will also be const (i.e. doesn't allow to change the values it points to). The iterator gets associated with the accessor of the base iterator.

Note that image iterators usually have a member `columnIterator()` which returns a column iterator optimized for that particular image class. ColumnIterator is only necessary if this 'native' column iterator is not usable in a particular situation or is not provided.

#include <vigra/imageiteratoradapter.hxx>
Namespace: vigra

## Member Typedef Documentation

typedef IMAGE_ITERATOR::value_type value_type

the iterator's value type

typedef IMAGE_ITERATOR::value_type PixelType

the iterator's value type

typedef IMAGE_ITERATOR::reference reference

the iterator's reference type (return type of `*iter`)

typedef IMAGE_ITERATOR::index_reference index_reference

the iterator's index reference type (return type of `iter[n]`)

typedef IMAGE_ITERATOR::pointer pointer

the iterator's pointer type (return type of `iter.operator->()`)

typedef IMAGE_ITERATOR::difference_type::MoveY difference_type

the iterator's difference type (argument type of `iter[diff]`)

typedef std::random_access_iterator_tag iterator_category

the iterator tag (random access iterator)

typedef IMAGE_ITERATOR Adaptee

the type of the adapted iterator

## Constructor & Destructor Documentation

ColumnIterator | ( | IMAGE_ITERATOR const & | i | ) |

Construct from an the image iterator to be adapted.

## Member Function Documentation

ColumnIterator& operator= | ( | ColumnIterator< IMAGE_ITERATOR > const & | i | ) |

Assignment.

ColumnIterator& operator= | ( | IMAGE_ITERATOR const & | i | ) |

Assign a new base iterator.

ColumnIterator operator+ | ( | int | d | ) | const

Construct iterator at a distance.

ColumnIterator operator- | ( | int | d | ) | const

Construct iterator at a distance.

int operator- | ( | ColumnIterator< IMAGE_ITERATOR > const & | c | ) | const

Calculate distance.

bool operator== | ( | ColumnIterator< IMAGE_ITERATOR > const & | c | ) | const

Equality.

bool operator!= | ( | ColumnIterator< IMAGE_ITERATOR > const & | c | ) | const

Inequality.

bool operator< | ( | ColumnIterator< IMAGE_ITERATOR > const & | c | ) | const

Smaller than.

reference operator* | ( |  | ) | const

Access current pixel.

index_reference operator[] | ( | int | d | ) | const

Access pixel at distance d.

pointer operator-> | ( |  | ) | const

Call member function of current pixel.

Adaptee& adaptee | ( |  | ) | const

Get a reference to the adapted iterator

The documentation for this class was generated from the following file:

- vigra/imageiteratoradapter.hxx

© Ullrich Köthe (ullrich.koethe@iwr.uni-heidelberg.de) Heidelberg Collaboratory for Image Processing, University of Heidelberg, Germany | html generated using doxygen and Python vigra 1.10.0